//OursFile.cpp

#include "stdafx.h"
#include "Orw.h"
#include "OrwFile.h"

#include <direct.h>		//for _chdir _getcwd
//////////////////////////////////////////////////////////
extern COrwApp* pApp;
//////////////////////////////////////////////////////////

short int ReadShortInt( char* pBuf, long int* pIndex)
{
	//obt@ short int ǂ//Index͍XVĕԂ
	char WorkBuf[ sizeof( short int)];
	short int* pNumber;
	char Char;
	for ( int ii = 0; ii < sizeof( short int) - 1; ii++)
	{
		Char = *(pBuf + *pIndex + ii);
		WorkBuf[ ii] = Char;
	}
	Char = *(pBuf + *pIndex + ii);
	WorkBuf[ ii] = Char;
	pNumber = (short int*)WorkBuf;
	*pIndex += ii + 1;
	return *pNumber;
}

long int ReadLongInt( char* pBuf, long int* pIndex)
{
	//obt@ long int (LONG) ǂ//Index͍XVĕԂ
	char WorkBuf[ sizeof( long int)];
	long int* pNumber;
	char Char;
	for ( int ii = 0; ii < sizeof( long int) - 1; ii++)
	{
		Char = *(pBuf + *pIndex + ii);
		WorkBuf[ ii] = Char;
	}
	Char = *(pBuf + *pIndex + ii);
	WorkBuf[ ii] = Char;
	pNumber = (long int*)WorkBuf;
	*pIndex += ii + 1;
	return *pNumber;
}

unsigned char ReadByte( char* pBuf, long int* pIndex)
{
	//obt@ BYTE(unsigned char) ǂ//Index͍XVĕԂ
	char WorkBuf[ sizeof( BYTE)];
	BYTE* pNumber;
	char Char;
	for ( int ii = 0; ii < sizeof( BYTE) - 1; ii++)
	{
		Char = *(pBuf + *pIndex + ii);
		WorkBuf[ ii] = Char;
	}
	Char = *(pBuf + *pIndex + ii);
	WorkBuf[ ii] = Char;
	pNumber = (BYTE*)WorkBuf;
	*pIndex += ii + 1;
	return *pNumber;
}

unsigned short int ReadWord( char* pBuf, long int* pIndex)
{
	//obt@ WORD(unsigned short int) ǂ//Index͍XVĕԂ
	char WorkBuf[ sizeof( unsigned short int)];
	unsigned short int* pNumber;
	char Char;
	for ( int ii = 0; ii < sizeof( unsigned short int) - 1; ii++)
	{
		Char = *(pBuf + *pIndex + ii);
		WorkBuf[ ii] = Char;
	}
	Char = *(pBuf + *pIndex + ii);
	WorkBuf[ ii] = Char;
	pNumber = (unsigned short int*)WorkBuf;
	*pIndex += ii + 1;
	return *pNumber;
}

BOOL ReadBool( char* pBuf, long int* pIndex)
{
	//obt@ BOOL ǂ//Index͍XVĕԂ
	char WorkBuf[ sizeof( BOOL)];
	BOOL* pBool;
	char Char;
	for ( int ii = 0; ii < sizeof( BOOL) - 1; ii++)
	{
		Char = *(pBuf + *pIndex + ii);
		WorkBuf[ ii] = Char;
	}
	Char = *(pBuf + *pIndex + ii);
	WorkBuf[ ii] = Char;
	pBool = (BOOL*)WorkBuf;
	*pIndex += ii + 1;
	return *pBool;
}

double ReadDouble( char* pBuf, long int* pIndex)
{
	//obt@ double ǂ//Index͍XVĕԂ
	char WorkBuf[ sizeof( double)];
	double* pValue;
	char Char;
	for ( int ii = 0; ii < sizeof( double) - 1; ii++)
	{
		Char = *(pBuf + *pIndex + ii);
		WorkBuf[ ii] = Char;
	}
	Char = *(pBuf + *pIndex + ii);
	WorkBuf[ ii] = Char;
	pValue = (double*)WorkBuf;
	*pIndex += ii + 1;
	return *pValue;
}

COLORREF ReadColorref( char* pBuf, long int* pIndex)
{
	//obt@ COLORREF ǂ//Index͍XVĕԂ
	char WorkBuf[ sizeof( COLORREF)];
	COLORREF* pColor;
	char Char;
	for ( int ii = 0; ii < sizeof( COLORREF) - 1; ii++)
	{
		Char = *(pBuf + *pIndex + ii);
		WorkBuf[ ii] = Char;
	}
	Char = *(pBuf + *pIndex + ii);
	WorkBuf[ ii] = Char;
	pColor = (COLORREF*)WorkBuf;
	*pIndex += ii + 1;
	return *pColor;
}

void ReadText( char* pBuf, long int* pIndex, int Size, char* pText)
{
	//obt@ TextRs[ĕԂ//Index͍XVĕԂ
	for ( int ii = 0; ii < Size; ii++)
	{
		char Char = *(pBuf + *pIndex + ii);
		*(pText + ii) = Char;
	}
	*pIndex += ii;
}

CString ReadString( char* pBuf, long int* pIndex, int Size)
{
	//obt@ CString Rs[ĕԂ//Index͍XVĕԂ
	CString String;
	for ( int ii = 0; ii < Size; ii++)
	{
		char Char = *(pBuf + *pIndex + ii);
		String += Char;
	}
	*pIndex += ii;
	return String;
}

////////////////////////////////////////////////////////////////
BOOL OursfilesDlg( int TypeExtSet, CStringArray* pStringArray, BOOL Mode)
{
	//OursFilȇI
	//Mode:Open(TRUE) Save(FALSE)
	char StrExt[ 10];
	char szFilter[ 128];
	if ( TypeExtSet & EXT_Our)
	{
		strcpy( StrExt, "our");
		strcpy( szFilter, "Ourş (*.our)|*.our|ׂĂ̧ (*.*)|*.*||");
	}
	char HelpPath[260];
	strcpy( HelpPath, pApp->m_pszHelpFilePath);
	char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
	_splitpath( HelpPath, drive, dir, fname, ext );
	CString DataPath = drive;
	DataPath += dir;
	
	char FileName[ 4096];
	strcpy( FileName, "");
	CFileDialog UFileDlg( Mode, StrExt, FileName, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_ALLOWMULTISELECT, szFilter, NULL);
	UFileDlg.m_ofn.lpstrFile = FileName;
	UFileDlg.m_ofn.nMaxFile = 4095;
	char dirname[ 256];
	if ( TypeExtSet & EXT_Our)
	{
		strcpy( dirname, DataPath);
	}
	UFileDlg.m_ofn.lpstrInitialDir = dirname;
	if ( UFileDlg.DoModal() == IDOK)
	{
		for ( POSITION pos = UFileDlg.GetStartPosition(); pos != NULL;)
		{
			CString FileFullPath = UFileDlg.GetNextPathName( pos);
			pStringArray->Add( FileFullPath);
		}
	}
	else
	{
		return FALSE;
	}
	return TRUE;
}

BOOL OursfileDlg( CString* pFilePath, CString* pFileName, int TypeExtSet, 
											int* pTypeExtGet, BOOL Mode, char FileType)
{
	//POursFilȇI
	//Mode:Open(TRUE) Save(FALSE)
	char StrExt[ 10];
	char szFilter[ 128];
	if ( TypeExtSet == EXT_Our)
	{
		if ( Mode)
		{
			strcpy( StrExt, "our");
			strcpy( szFilter, "Ourş (*.our)|*.our|ׂĂ̧ (*.*)|*.*||");
		}
		else
		{
			strcpy( StrExt, "our");
			strcpy( szFilter, "Ourş (*.our)|*.our|DXF̧ (*.dxf)|*.dxf|ׂĂ̧ (*.*)|*.*||");
		}
	}
	char FileName[ 256];
	strcpy( FileName, *pFileName);
	CFileDialog UFileDlg( Mode, StrExt, FileName, 
						OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, szFilter, NULL);
	char HelpPath[260];
	strcpy( HelpPath, pApp->m_pszHelpFilePath);
	char drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
	_splitpath( HelpPath, drive, dir, fname, ext );
	CString DataPath = drive;
	DataPath += dir;
	char dirname[ 256];
	if ( FileType == FILE_Ours)
	{
		strcpy( dirname, DataPath);
	}
	UFileDlg.m_ofn.lpstrInitialDir = dirname;
	if ( UFileDlg.DoModal() == IDOK)
	{
		*pFilePath = UFileDlg.GetPathName();
		*pFileName = UFileDlg.GetFileTitle();	//GetFileName()͊gqt
		CString Ext = UFileDlg.GetFileExt();
		Ext.MakeLower();
		if ( Ext == "our")
		{
			*pTypeExtGet = EXT_Our;
		}
		char CurrentPath[ 256];
		_getcwd( CurrentPath, 255);				//JgpXɂ͍Ō\͕tȂ
	}
	else
	{
		return FALSE;
	}
	return TRUE;
}

////////////////////////////////////////////////////////////////

void SetSeekDataText( DWORD SizeMax, char* pbuf, CString* pString, unsigned long int* pIndex)
{
	int Length = pString->GetLength();
	if ( pbuf != NULL && *pIndex + Length + 2 < SizeMax)
	{
		for ( int ii = 0; ii < Length; ii++)
		{
			*(pbuf + *pIndex + ii) = pString->GetAt( ii);
		}
		*pIndex += Length;
		*( pbuf + *pIndex) = 0x0D;
		*( pbuf + *pIndex + 1) = 0x0A;
		*pIndex += 2;
	}
	else
	{
		*pIndex += Length;
		*pIndex += 2;
	}
}

void SetSeekData( DWORD SizeMax, char* pbuf, CString* pString, unsigned long int* pIndex)
{
	int Length = pString->GetLength();
	if ( pbuf != NULL && *pIndex + Length < SizeMax)
	{
		for ( int ii = 0; ii < Length; ii++)
		{
			*(pbuf + *pIndex + ii) = pString->GetAt( ii);
		}
	}
	*pIndex += Length;
}

void SetSeekData( DWORD SizeMax, char* pbuf, BYTE* pBite, unsigned long int* pIndex)
{
	int Size = sizeof( BYTE);
	if ( pbuf != NULL && *pIndex + Size < SizeMax)
	{
		char* pWorkBuf = (char*)pBite;
		for ( int ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBuf + ii);
		}
	}
	*pIndex += Size;
}

void SetSeekData( DWORD SizeMax, char* pbuf, BOOL* pBool, unsigned long int* pIndex)
{
	int Size = sizeof( BOOL);
	if ( pbuf != NULL && *pIndex + Size < SizeMax)
	{
		char* pWorkBuf = (char*)pBool;
		for ( int ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBuf + ii);
		}
	}
	*pIndex += Size;
}

void SetSeekData( DWORD SizeMax, char* pbuf, short int* pNumber, unsigned long int* pIndex)
{
	int Size = sizeof( short int);
	if ( pbuf != NULL && *pIndex + Size < SizeMax)
	{
		char* pWorkBuf = (char*)pNumber;
		for ( int ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBuf + ii);
		}
	}
	*pIndex += Size;
}

void SetSeekDataSize( DWORD SizeMax, char* pbuf, unsigned short int* pNumber, unsigned long int Index)
{
	int Size = sizeof( unsigned short int);
	if ( Index + Size >= SizeMax) return;
	char* pWorkBuf = (char*)pNumber;
	for ( int ii = 0; ii < Size; ii++)
	{
		*(pbuf + Index + ii) = *(pWorkBuf + ii);
	}
}

void SetSeekData( DWORD SizeMax, char* pbuf, unsigned short int* pNumber, unsigned long int* pIndex)
{
	int Size = sizeof( unsigned short int);
	if ( pbuf != NULL && *pIndex + Size < SizeMax)
	{
		char* pWorkBuf = (char*)pNumber;
		for ( int ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBuf + ii);
		}
	}
	*pIndex += Size;
}

void SetSeekData( DWORD SizeMax, char* pbuf, long int* pNumber, unsigned long int* pIndex)
{
	int Size = sizeof( long int);
	if ( pbuf != NULL && *pIndex + Size < SizeMax)
	{
		char* pWorkBuf = (char*)pNumber;
		for ( int ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBuf + ii);
		}
	}
	*pIndex += Size;
}

void SetSeekData( DWORD SizeMax, char* pbuf, double* pValue, unsigned long int* pIndex)
{
	int Size = sizeof( double);
	if ( pbuf != NULL && *pIndex + Size < SizeMax)
	{
		char* pWorkBuf = (char*)pValue;
		for ( int ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBuf + ii);
		}
	}
	*pIndex += Size;
}

void SetSeekData( DWORD SizeMax, char* pbuf, CPoint2D* pPoint2D, unsigned long int* pIndex)
{
	int Size = sizeof( double);
	if ( pbuf != NULL && *pIndex + Size * 2 < SizeMax)
	{
		char* pWorkBufA = (char*)&pPoint2D->x;
		for ( int ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBufA + ii);
		}
		*pIndex += Size;
		char* pWorkBufB = (char*)&pPoint2D->y;
		for ( ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBufB + ii);
		}
		*pIndex += Size;
	}
	else
	{
		*pIndex += Size;
		*pIndex += Size;
	}
}

void SetSeekData( DWORD SizeMax, char* pbuf, COLORREF* pColor, unsigned long int* pIndex)
{
	int Size = sizeof( COLORREF);
	if ( pbuf != NULL && *pIndex + Size < SizeMax)
	{
		char* pWorkBuf = (char*)pColor;
		for ( int ii = 0; ii < Size; ii++)
		{
			*(pbuf + *pIndex + ii) = *(pWorkBuf + ii);
		}
	}
	*pIndex += Size;
}

////////////////////////////////////////////////////////////////
