// MainFrm.cpp : CMainFrame NX̓̒`s܂B

#include "stdafx.h"
#include "Orw.h"

#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	//}}AFX_MSG_MAP
	// O[o wv R}h
	ON_COMMAND(ID_HELP_FINDER, CMDIFrameWnd::OnHelpFinder)
	ON_COMMAND(ID_HELP, CMDIFrameWnd::OnHelp)
	ON_COMMAND(ID_CONTEXT_HELP, CMDIFrameWnd::OnContextHelp)
	ON_COMMAND(ID_DEFAULT_HELP, CMDIFrameWnd::OnHelpFinder)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // Xe[^X C CWP[^
	ID_INDICATOR_KANA,
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̍\z/

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // 쐬Ɏs
	}
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // 쐬Ɏs
	}
	// TODO: c[ `bvXKvȂꍇA폜ĂB
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);
	// TODO: c[ o[hbLO\ɂȂꍇ͈ȉ̂Rs폜ĂB
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: ̈ʒu CREATESTRUCT cs CāAWindow NXX^CCĂB
	return CMDIFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame NX̐ff

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

void CMainFrame::InitialShowWindow( UINT nCmdShow)
{
	WINDOWPLACEMENT wp;
	if ( !ReadWindowPlacement( &wp))
	{
		ShowWindow( nCmdShow);
		return;
	}
	if ( nCmdShow != SW_SHOWNORMAL)
	{
		wp.showCmd = nCmdShow;
	}
	SetWindowPlacement( &wp);
	ShowWindow( wp.showCmd);
}

BOOL CMainFrame::ReadWindowPlacement( LPWINDOWPLACEMENT pwp)
{
	char BASED_CODE szSection[] = "Settings";
	char BASED_CODE szWindowPos[] = "WindowPos";
	char szFormat[] = "%u,%u,%d,%d,%d,%d,%d,%d,%d,%d";
	CString strBuffer = AfxGetApp()->GetProfileString( szSection, szWindowPos);
	if ( strBuffer.IsEmpty())
	{
		return FALSE;
	}
	WINDOWPLACEMENT wp;
	int nRead = sscanf(strBuffer, szFormat,
		&wp.flags, &wp.showCmd,
		&wp.ptMinPosition.x, &wp.ptMinPosition.y,
		&wp.ptMaxPosition.x, &wp.ptMaxPosition.y,
		&wp.rcNormalPosition.left, &wp.rcNormalPosition.top,
		&wp.rcNormalPosition.right, &wp.rcNormalPosition.bottom);
	if (nRead != 10)
	{
		return FALSE;
	}
	wp.length = sizeof wp;
	*pwp = wp;
	return TRUE;
}

void CMainFrame::WriteWindowPlacement( LPWINDOWPLACEMENT pwp)
{
	//AvP[V INIt@C̐ݒpZNVɃEBhE̔zu
	char BASED_CODE szSection[] = "Settings";
	char BASED_CODE szWindowPos[] = "WindowPos";
	char szFormat[] = "%u,%u,%d,%d,%d,%d,%d,%d,%d,%d";
	char szBuffer[sizeof("-32767")*8 + sizeof("65535")*2];
	sprintf( szBuffer, szFormat,
		pwp->flags, pwp->showCmd,
		pwp->ptMinPosition.x, pwp->ptMinPosition.y,
		pwp->ptMaxPosition.x, pwp->ptMaxPosition.y,
		pwp->rcNormalPosition.left, pwp->rcNormalPosition.top,
		pwp->rcNormalPosition.right, pwp->rcNormalPosition.bottom);
	AfxGetApp()->WriteProfileString( szSection, szWindowPos, szBuffer);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame bZ[W nh

void CMainFrame::OnClose() 
{
	// jOɃEBhËʒui[܂B
	WINDOWPLACEMENT wp;
	wp.length = sizeof wp;
	if ( GetWindowPlacement( &wp))
	{
		wp.flags = 0;
		if ( IsZoomed())
		{
			wp.flags |= WPF_RESTORETOMAXIMIZED;
		}
		WriteWindowPlacement( &wp);
	}
	CMDIFrameWnd::OnClose();
}
